const tieneSoporteUserMedia = () =>
    !!(navigator.getUserMedia || (navigator.mozGetUserMedia || navigator.mediaDevices.getUserMedia) || navigator.webkitGetUserMedia || navigator.msGetUserMedia)
const expresiones = {
      Nombre: /^[a-zA-ZÀ-ÿ\s]{1,50}$/,
      Correo: /^(?:[^<>()[\].,;:\s@"]+(\.[^<>()[\].,;:\s@"]+)*|"[^\n"]+")@(?:[^<>()[\].,;:\s@"]+\.)+[^<>()[\]\.,;:\s@"]{2,63}$/i
}    
const $video = document.querySelector("#video"),
      $boton = document.querySelector("#boton"),
      $canvas = document.querySelector("#canvas"),
      $form = document.querySelector("#form_diploma"),
      $tabs = document.querySelectorAll(".tab-exercise"),
      $boton_clean = document.querySelector("#boton-clean"),
      $foto_tomada = document.querySelector(".foto-tomada"),
      $input = document.querySelectorAll(".info-user-diploma"),
      $btn_reload = document.querySelectorAll(".btn-reload"),
      $content_video = document.querySelector(".live-camera"),
      $overlay = document.querySelector(".section-calendar .contentainer-diploma .bg-diploma .form-diploma .camera .overlay-camera");
/********************************************************************
*********************************************************************
*********************************************************************
********************************************************************* 
********************************************************************/ 
// 
const getExercises = async() => {
    try {
      const res = await fetch('https://canalonce.mx/REST/data/mdb/ejercicios.json');
      const val = await res.json();
      return val;
    }
    catch (error) {
        // alert(error)
        console.log(error)
    }
}
const getDates = (dataLimit) => {
  let currentDay = moment().format('YYYY-MM-DD');
  return getDataSchedules(currentDay, dataLimit)
}
const getElement = (id, ele) => {
  return document.querySelector('#'+id+' '+ele);
}
/**
* @description Funcion que obtiene un elemento html
*/   
const getQueryElement = (element) => {
  return document.querySelector(element);
}  
/**
 * @description Función agrega una clase varios elementos html
*/   
const getAllElement = (element) => {
  return document.querySelectorAll(element);
}
const getValues = (element) => {
  return  document.querySelector('.'+element).value;
}
/**
 * @description Función agrega una clase a un elemento html
*/ 
const addClassElement = (element, typeClass) => {
  element.classList.add(typeClass);
}
/**
 * @description Función que remueve una clase de varios elementos html
*/ 
const addAllClass = (elements, typeClass) => {
  elements.forEach(div => {
      div.classList.add(typeClass);
  });
}
/**
 * @description Función remueve una clase de un elemento html
*/ 
const removeClass = (element, typeClass) => {
  element.classList.remove(typeClass);
}
/**
 * @description Función que remueve una clase de varios elementos html
*/ 
const removeAllClass = (elements, typeClass) => {
  elements.forEach(div => {
      div.classList.remove(typeClass);
  });
}
/**
 * @description Funcion que genera un array con las fechas 15 dias antes y 15 despues
 * @param startDate Fecha de inicio del arregl, datao
 * @param stopDate Fecha del final del arreglo
*/ 
const getDataSchedules = (startData, stopData) => {
  let data = [];
  let current = moment(startData, 'YYYY-MM-DD');
  for (let i = 0; i < stopData; i++) {
    data.push( moment(current).format('YYYY-MM-DD') )
    current = moment(current).add(1, 'days');        
  }
  return data;         
}
const setNewValues = (element, newscore, type) => {
  if(type === 1){
    document.querySelector('#'+element).dataset.status = newscore;
  }else{
    document.querySelector('#'+element).dataset.video = newscore;
  }
}
const settingsClassDesktop = () => {
  var mobile = {
                  Android: function() {
                    return navigator.userAgent.match(/Android/i);
                  },
                  BlackBerry: function() {
                    return navigator.userAgent.match(/BlackBerry/i);
                  },
                  iOS: function() {
                    return navigator.userAgent.match(/iPhone|iPad|iPod/i);
                  },
                  Opera: function() {
                    return navigator.userAgent.match(/Opera Mini/i);
                  },
                  Windows: function() {
                    return navigator.userAgent.match(/IEMobile/i);
                  },
                  any: function() {
                    return (mobile.Android() || mobile.BlackBerry() || mobile.iOS() || mobile.Opera() || mobile.Windows()) ;
                  }
              };
  if(mobile.any() == null) {
    const Items = document.querySelectorAll('.item-schedule-active');
    Items.forEach((ele) =>{            
        ele.classList.add('item-desktop')
    });
  }
}
const statusExercises = (status) => {
  let ele = []
  switch (status) {
    case 1:
      ele.push('', '', 'd-none')          
      break;
    case 2:
      ele.push('', 'd-none', '')          
      break;      
    default:
      ele.push('d-none', '', '')
      break;
  }
  return ele;
}
const setItemsExercises = (info, tipo_categoria) => {
    const contentItems = document.querySelector('.container-calendar .schedule-calendar');
    let html = '';
        info.forEach((element, key) => {
          if(element.categoria == tipo_categoria){      
            let dia = (key < 9) ? '0'+(key + 1) :  key + 1;
            let descripcion = (element.descripcion != '*') ? element.descripcion: '';
            let iframe = element.iframe;
            let tipoEjercicio = (element.tipo_ejericio != '*') ? element.tipo_ejericio : '';
            let classTitle = (element.dia == '1' ) ? 'color-day-exercises':  'color-day-rest';
            let classExercisesActive = (element.dia == '1' ) ? 'item-schedule-active':  'item-schedule-rest'; 
            let classExercises = (element.dia == '0' ) ? 'd-none':  ''; 
            let classStatusExercises = statusExercises(element.status); 
            let img = ( element.imagen != '*') 
                                ? '<picture>'+
                                    '<img class="img-fluid" '+
                                          'src="images/'+element.imagen+'" '+
                                          'alt="Exercises" width="30" height="25" data-id="exercises-'+dia+'">'+
                                  '</picture>'
                                : '';   
            html += '<div class="item-schedule schedule-'+tipo_categoria+' '+classExercisesActive+'"'+
                          'id="exercises-'+dia+'"'+
                          'data-key="'+element.id+'"'+
                          'data-id="exercises-'+dia+'"'+
                          'data-status="'+element.status+'"'+
                          'data-video="'+element.status_video+'"'+
                          'data-description="'+descripcion+'"'+
                          'data-titulo="'+element.titulo+'"'+
                          'data-tipo="'+tipoEjercicio+'"'+
                          'data-frase="'+element.frase+'"'+
                          'data-equipo="'+element.equipo+'"'+
                          'data-imagen="'+element.imagen+'"'+
                          'data-info="'+iframe+'" >'+
                      '<div class="container-exercises-status '+classStatusExercises[0]+'" data-id="exercises-'+dia+'">'+
                        '<div class="check-complete '+classStatusExercises[1]+'" data-id="exercises-'+dia+'">'+
                        '</div>'+
                        '<div class="check-no-complete '+classStatusExercises[2]+'" data-id="exercises-'+dia+'">'+
                        '</div>'+
                      '</div>'+                    
                      '<div class="title-schedule d-flex justify-content-center" data-id="exercises-'+dia+'">'+
                        '<h2 class="text-uppercase '+classTitle+'" data-id="exercises-'+dia+'"> Día '+dia+'</h2>'+
                        '<p class="text-uppercase" data-id="exercises-'+dia+'">'+element.titulo+'</p>'+
                        '<hr class="w-100" data-id="exercises-'+dia+'">'+
                      '</div>'+
                      '<div class="info-exercises d-flex justify-content-center w-100" data-id="exercises-'+dia+'">'+  
                        '<div class="description-exercises d-flex w-100 '+classExercises+'" data-id="exercises-'+dia+'">'+
                          img+
                          '<p class="text-bold" data-id="exercises-'+dia+'">'+tipoEjercicio+'</p>'+
                        '</div>'+
                        '<div class="text-exercises w-100" data-id="exercises-'+dia+'">'+
                            '<small class="text-uppercase" data-id="exercises-'+dia+'">'+element.frase+'</small>'+
                        '</div>'+
                      '</div>'+
                    '</div>';
          }
        });
        contentItems.innerHTML = html;
        clickExercises();
        settingsClassDesktop();
        clickExercisesRest();
}
const clickExercises = () => {
    const Items = document.querySelectorAll('.item-schedule-active');
    Items.forEach((ele) =>{            
        ele.addEventListener('click', showDetailsExercises);
    });
}
const clickExercisesRest = () => {
    const Items = document.querySelectorAll('.item-schedule-rest');
    Items.forEach((ele) =>{            
        ele.addEventListener('click', alertRestDay);
    });
}
const alertDisclaimer = () => {
  // localStorage.setItem("Disclaimer", JSON.stringify(null));
  if(JSON.parse(localStorage?.getItem("Disclaimer")) == null){ 
    let body = document.querySelector('html');
        body.classList.add('body-overflow');  
    let labelTitle = document.createElement("h2");
        labelTitle.classList.add('color-day-exercises', 'font-size-2', 'font-bold')
        labelTitle.innerHTML = 'Disclaimer';
    let title = 'Titulo'; 
    let description = 'Lorem ipsum dolor sit amet consectetur adipisicing elit. Velit eligendi temporibus molestias ex veniam necessitatibus sequi nisi maiores earum nemo ducimus, magnam amet ipsum minima. Distinctio, cupiditate! Quia, laboriosam. Commodi!'
    // 
    let itemModal = '<div class="description-exercices">'+
                      '<p> '+description+' </p>'+
                    '</div>';      
    let content = document.createElement("div");
        content.classList.add('info-modal-exercises')
        content.innerHTML = itemModal;     
    alertify.confirm()
            .setting({
                      'label': 'Cerrar',
                      'closable': false,
                      'title': labelTitle,
                      'message': content,
                      'invokeOnCloseOff': false,
                      'autoReset': true,
                      'pinnable': false, 
                      'modal': true,
                      'closableByDimmer': true,
                      'transitionOff': true,
                      'maintainFocus': false,
                      'overflow': false,
                      'labels': {ok:' ¡De acuerdo!', cancel:'salir'},
                      'onok': function( ){
                        body.classList.remove('body-overflow')
                        content.remove();
                        localStorage.setItem("Disclaimer", JSON.stringify(1));
                      },
                      'oncancel': function(){
                        window.location.href = "https://canalonce.mx/";
                        localStorage.setItem("Disclaimer", JSON.stringify(null));                        
                      },
                      'onclose': function(){
                        console.log('close');
                      }
                    }).show();                      
  }
}
const alertRestDay = (e) => {
  // alertify.error('Día de descanso')
  let body = document.querySelector('html');
      body.classList.add('body-overflow');   
  let id = e.target.dataset.id;
  let item = getElement(id, '');
  let idJson = item.dataset.key; 
  // 
  let iframe = item.dataset.info; 
  let video = 'https://canaloncetv.s3.us-east-1.amazonaws.com/REST/data/trailer/ep_spot_ep2_v1.mp4'; 
  // 
  let statusvideo = (item.dataset.video == 1) ? 'checked': '';
  let statusSucess = (item.dataset.status == 1) ? 'checked': '';
  let statusError = (item.dataset.status == 2) ? 'checked':'';
  let classStatusVideo = (item.dataset.video == 1) ? '': 'd-none';
  let description = (item.dataset.description != '') ? item.dataset.description : ''; 
  let tipo = (item.dataset.tipo != '') ? '<p>° '+item.dataset.tipo+'</p>' : ''; 
  let imgC = item.dataset.imagen; 
  let frase = (item.dataset.frase != '') ?  item.dataset.frase  : ''; 
  // 
  let title = getElement(id, '.title-schedule p'); 
  let dia = getElement(id, '.title-schedule h2'); 
  let labelTitle = document.createElement("h2");
      labelTitle.classList.add('color-day-exercises', 'font-size-2', 'font-bold')
      labelTitle.innerHTML = 'Día de Nutrición';
  // 
  let itemModal = '<div class="container-title">'+
                    '<h2>'+title.innerHTML+'</h2>'+
                  '</div>'+
                  '<div class="container-iframe">'+
                    '<video id="VideoPlayer_'+id+'" class="video-js vjs-default-skin vjs-big-play-centered vjs-16-9" '+
                            'controls data-setup="" width="640" height="264" poster="">'+
                    '</video>'+
                  '</div>'+
                  '<div class="description-exercices">'+
                    '<p> <strong>Sinopsis: </strong> '+description+' </p>'+
                    '<p> <strong>Receta: </strong> '+frase+' </p>'+
                  '</div>';
  // 
  let content = document.createElement("div");
      content.classList.add('info-modal-exercises')
      content.innerHTML = itemModal; 
      alertify.alert()
              .setting({
                        'label': 'Cerrar',
                        'closable': true,
                        'title': labelTitle,
                        'message': content,
                        'invokeOnCloseOff': false,
                        'autoReset': true,
                        'pinnable': false, 
                        'modal': true,
                        'closableByDimmer': true,
                        'transitionOff': true,
                        'maintainFocus': false,
                        'overflow': false,
                        'onok': function( ){
                        },
                        'onclose': function(){
                          body.classList.remove('body-overflow')
                          content.remove();
                          videojs('VideoPlayer_'+id).dispose()
                        }
                      }).show();  
    PlayEpisode(id, iframe);

}
const showDetailsExercises = (e) => {  
  let body = document.querySelector('html');
      body.classList.add('body-overflow');   
  let id = e.target.dataset.id;
  let item = getElement(id, '');
  let idJson = item.dataset.key; 
  // 
  let iframe = item.dataset.info; 
  let video = 'https://canaloncetv.s3.us-east-1.amazonaws.com/REST/data/trailer/ep_spot_ep2_v1.mp4'; 
  // 
  let statusvideo = (item.dataset.video == 1) ? 'checked': '';
  let statusSucess = (item.dataset.status == 1) ? 'checked': '';
  let statusError = (item.dataset.status == 2) ? 'checked':'';
  let classStatusVideo = (item.dataset.video == 1) ? '': 'd-none';
  let description = item.dataset.description; 
  let titulo = item.dataset.titulo; 
  let tipo = item.dataset.tipo; 
  let imgC = item.dataset.imagen; 
  let frase = item.dataset.frase; 
  let equipo = item.dataset.equipo; 
  // 
  let title = getElement(id, '.title-schedule p'); 
  let image = getElement(id, '.description-exercises img'); 
  // 
  let discipline = (title.innerHTML != '') ? '<picture>'+
                                                '<img class="img-fluid" src="'+image.src+'" alt="Exercises" width="30" height="25" data-id="exercises-20">'+
                                              '</picture>'+frase : '';     
  let calories = (tipo != '') ?  '<picture>'+
                                              '<img class="img-fluid" src="images/fire.png" alt="Exercises" width="30" height="25" data-id="exercises-20">'+  
                                            '</picture>'+tipo : '';     
  let equipment = (equipo != '') ? '<picture>'+
                                      '<img class="img-fluid" src="images/dumbbell.png" alt="Exercises" width="30" height="25" data-id="exercises-20">'+
                                    '</picture>'+ equipo : '';  
  //  
  let dia = getElement(id, '.title-schedule h2'); 
  let labelTitle = document.createElement("h2");
      labelTitle.classList.add('title-modal', 'font-size-2', 'font-bold')
      labelTitle.innerHTML = 'Ejercicio del ' +dia.innerHTML
  let itemModal = '<div class="container-title">'+
                    '<h2>'+titulo+'</h2>'+
                  '</div>'+
                  '<div class="container-iframe">'+
                    '<video id="VideoPlayer_'+id+'" class="video-js vjs-default-skin vjs-big-play-centered vjs-16-9" '+
                            'controls data-setup="" width="640" height="264" poster="">'+
                    '</video>'+
                  '</div>'+
                  '<div class="description-exercices">'+
                    '<div class="discipline">'+ discipline +'</div>'+
                    '<div class="calories">'+ calories +'</div>'+
                    '<div class="equipo">'+ equipment +'</div>'+                    
                  '</div>'+
                  '<div class="container-status-video d-none">'+
                      '<input id="status_video" class="status_video status_'+id+'" '+
                              'name="status_video" type="radio" '+statusvideo+' value="1" />'+
                  '</div>'+
                  '<div class="container-status-exercises '+classStatusVideo+'">'+
                    '<h2>¿Terminaste el ejercicio?</h2>'+
                    '<div class="status status-success">'+
                      '<h4> Si </h4>'+
                      '<label class="checkbox" style="font-size: 10vmin">'+                          
                        '<input id="status_success" class="status_exercises status_'+id+'" '+
                               'name="status_exercises" type="radio" '+statusSucess+' value="1" />'+
                        '<div class="check"></div>'+
                      '</label>'+
                    '</div>'+
                    '<div class="status status-error">'+
                      '<h4> No </h4>'+
                      '<label class="checkbox" style="font-size: 10vmin">'+                          
                        '<input id="status_error" class="status_exercises status_'+id+'" '+
                               'name="status_exercises" type="radio" '+statusError+' value="2"/>'+
                        '<div class="check"></div>'+
                      '</label>'+
                    '</div>'+
                  '</div>';
  let content = document.createElement("div");
      content.classList.add('info-modal-exercises')
      content.innerHTML = itemModal;  
      alertify.alert()
              .setting({
                        'label': 'Cerrar',
                        'closable': true,
                        'title': labelTitle,
                        'message': content,
                        'invokeOnCloseOff': false,
                        'autoReset': true,
                        'pinnable': false, 
                        'modal': true,
                        'closableByDimmer': true,
                        'transitionOff': true,
                        'maintainFocus': false,
                        'overflow': false,
                        'onok': function( ){
                          let status =  getValueStatusRadio();
                          let statusVideo =  getValueStatusVideo();
                          updateInfoExercises(id, idJson, status, statusVideo);
                          // statusBtnDiploma();
                        },
                        'onclose': function(){
                          body.classList.remove('body-overflow')
                          content.remove();
                          videojs('VideoPlayer_'+id).dispose()
                        }
                      }).show();
    PlayEpisode(id, iframe);
}
/**
 * @description Funcion que reproduce el episodio
 * @param id Id del episodio
 * @param video Video en formato youtube, vimeo, m3u8 o mp4
*/ 
function PlayEpisode(id, video) {
  // 
  var options = { 
        plugins: {
          httpSourceSelector:
          {
          default: 'auto'
          },
        },  
        techOrder: [ 'chromecast', 'html5', 'youtube', 'vimeo' ],
        controls: true,
        html5:{
          hls: {
            overrideNative: !videojs.browser.IS_SAFARI,
          },
        },
        controlBar: {
          volumePanel: {
            inline: false,
            volumeControl: {
              vertical: true
            }
          },
          fullscreenToggle: false
        },    
        youtube: {
          ytControls: 2,
          playsinline: 0,
          modestbranding: 1,
          iv_load_policy: 3,
          cc_load_policy: 0,
          
          rel: 0,
        },
    };  
  let idVideo = 'VideoPlayer_'+id;
  videojs.registerPlugin('apiVideoAnalytics', VideoJsApiVideoAnalytics);
  var reproductor =  videojs(idVideo, {options});  
      reproductor.apiVideoAnalytics({
          events: [
            {
              name: 'play',
              label: 'video play',
              action: 'play',
              event_label: video,
            },
            {
              name: 'fullscreenchange',
              label: {
                open: 'video fullscreen open',
                exit: 'video fullscreen exit'
              },
              action: 'fullscreen change',
              event_label: video,
            },
            {
              name: 'timeupdate',
              action: 'time updated',
              event_label: video,
            }
          ]            
        });
  if (video.includes('m3u8')) {
    reproductor.httpSourceSelector();
    reproductor.chromecast();
    reproductor.landscapeFullscreen({
                                    fullscreen: {
                                                enterOnRotate: true,
                                                exitOnRotate: true,
                                                alwaysInLandscapeMode: true,
                                                iOS: false
                                    }  
                                  });
    reproductor.src({ type: 'application/x-mpegURL', src: video });        
    reproductor.controls(true);
    reproductor.playsinline(true);
    reproductor.autoplay(true); 
  }else if (video.includes('vimeo')) {
    var repVimeo =  videojs('VideoPlayer', {});  
        repVimeo.chromecast();

        repVimeo.apiVideoAnalytics({
                                    events: [
                                      {
                                        name: 'play',
                                        label: 'video play',
                                        action: 'play',
                                        event_label: video,
                                      },
                                      {
                                        name: 'fullscreenchange',
                                        label: {
                                          open: 'video fullscreen open',
                                          exit: 'video fullscreen exit'
                                        },
                                        action: 'fullscreen change',
                                        event_label: video,
                                      },
                                      {
                                        name: 'timeupdate',
                                        action: 'time updated',
                                        event_label: video,
                                      }
                                    ]            
                                  });
        repVimeo.reset();
        repVimeo.src({ techOrder: ["vimeo"], type: 'video/vimeo', src: video});
        repVimeo.controls(true);
        repVimeo.playsinline(true);
        repVimeo.autoplay(true);   
        repVimeo.on('ended', function() {
          // this.dispose();
        });   
  }else if (video.includes('youtu.be') || video.includes('youtube') ||  video.includes('youtu')){
    reproductor.httpSourceSelector();
    reproductor.chromecast();
    reproductor.landscapeFullscreen({
                                    fullscreen: {
                                                enterOnRotate: true,
                                                exitOnRotate: true,
                                                alwaysInLandscapeMode: true,
                                                iOS: false
                                    }  
                                  });
    reproductor.src({ type: 'video/youtube', src: video });          
    reproductor.controls(true);
    reproductor.playsinline(false);
  }else{
    reproductor.httpSourceSelector();
    reproductor.chromecast();
    reproductor.landscapeFullscreen({
                                    fullscreen: {
                                                enterOnRotate: true,
                                                exitOnRotate: true,
                                                alwaysInLandscapeMode: true,
                                                iOS: false
                                    }  
                                  });
    reproductor.src({ type: 'video/mp4', src: video });          
    reproductor.controls(true);
    reproductor.playsinline(false);
  }  
  reproductor.on('ended', function() {
    let checkVideo = document.querySelector("#status_video");      
    let checkExce = document.querySelector("#status_success");      
        checkVideo.checked = true;
        checkExce.checked = true;
    let contentEx = document.querySelector('.container-status-exercises');
        contentEx.classList.remove('d-none');
  });
}
const getValueStatusRadio = () => {
  let res = 0;
  let radio =  document.querySelectorAll('.status_exercises');
      radio.forEach(element => {
        if(element.checked){
          res = element.value;
        }
      });
  return res;
}
const getValueStatusVideo = () => {
  let res = 0;
  let radio =  document.querySelector('.status_video');
      if(radio.checked){
        res = radio.value;
      }
  return res;
}
const completeDataStorage = async(tipo) => {
  let data = []
  let info = await getExercises();
  let days = getDates(info.length);
  for (let index = 0; index < info.length; index++) {
    if(parseInt(info[index].tipo) === tipo){
      data.push({ "id": info[index].id,
                  "titulo": info[index].titulo,
                  "ejericicio": info[index].ejericicio,
                  "tipo_ejericio": info[index].tipo_ejericio,
                  "categoria": info[index].tipo,
                  "frase": info[index].frase,
                  "descripcion": info[index].descripcion,
                  "imagen": info[index].imagen,
                  "imagenW": info[index].imagenW,
                  "iframe": info[index].iframe,
                  "status": info[index].status,
                  "equipo": info[index].equipo,
                  "status_video": 0,
                  "fecha": days[index],
                  "dia": info[index].dia
                });            
    }
  }      
  return data;
}
const updateInfoExercises = (idEle, idJson, status, statusVideo) => {
  let categoria_activa = getQueryElement('.tab-active');  
  let response = getDataCategorie(categoria_activa.dataset.categoria);
      localStorage.setItem("Categoria", JSON.stringify(categoria_activa.dataset.categoria));   
  let data = [];
      response.map(ele => {
        if(ele.id == idJson){
          ele.status = parseInt(status);
          ele.status_video = parseInt(statusVideo)
        }
      }); 
      localStorage.setItem(`_${categoria_activa.dataset.categoria}`, JSON.stringify(response)); 
  var classStatus = ['container-exercises-status', 'check-complete', 'check-no-complete']
  let newStatusExercises = statusExercises(parseInt(status)); 
  setNewValues(idEle, parseInt(status), 1);
  setNewValues(idEle, parseInt(statusVideo), 2);
  setNewClassByStatus(idEle, classStatus, newStatusExercises);
}
const setNewClassByStatus = (id, classStatus, newClass) => {
  for (let i = 0; i < classStatus.length; i++) {
    document.querySelector('#'+id+' .'+classStatus[i]).classList.remove("d-none");
    if(newClass[i] != ''){
      document.querySelector('#'+id+' .'+classStatus[i]).classList.add(''+newClass[i]);           
    }
  }
}
const parserStatus = (status) => {
  let data = 0;
  switch (status) {
    case 1:
      data = 1;
      break;
    case 2:
      data = 2;
      break;      
  }
  return data;
}
const getDataCategorie = (categoria) => {  
  return JSON.parse(localStorage?.getItem(`_${categoria}`))
}
// localStorage.clear();
const readLocalStorage = async() => { 
  let categoria_activa = getQueryElement('.tab-active');
  // 
  if(JSON.parse(localStorage?.getItem("Categoria")) == null){    
    const ejercicios_b = await completeDataStorage(1);  
    const ejercicios_i = await completeDataStorage(2);  
    const ejercicios_a = await completeDataStorage(3);  
    // 
    localStorage.setItem("Categoria", JSON.stringify(categoria_activa.dataset.categoria));
    localStorage.setItem("_1", JSON.stringify(ejercicios_b));
    localStorage.setItem("_2", JSON.stringify(ejercicios_i));
    localStorage.setItem("_3", JSON.stringify(ejercicios_a));
    // 
    let data =  getDataCategorie(categoria_activa.dataset.categoria)  
    console.log('vacio')      
    setItemsExercises(data, categoria_activa.dataset.categoria);    
  }else{            
    console.log('lleno')           
    const categoria = JSON.parse(localStorage?.getItem("Categoria"));
    let data = getDataCategorie(categoria);  
    setItemsExercises(data, categoria);    
  }
}
const comprobationDiploma = () => {  
  getVideo();
  let body = document.querySelector('html');
      body.classList.add('body-overflow');  
  let diploma = document.querySelector('.contentainer-diploma');
  let content = document.querySelector('.contentainer-diploma');
      removeClass(content, 'd-none');
  if(JSON.parse(localStorage?.getItem("dataUser")) != null){
    let dataUser = JSON.parse( localStorage?.getItem("dataUser") );
    let info = [];
        dataUser.map(ele => {
          if (ele.status === 1){
            info.push(ele); 
          }
        });
    if(info.length === 27){
      removeClass(diploma, 'd-none');
    }else{
      console.log(info.length);
    }    
  }
}
const closeForm = () => {  
  let body = document.querySelector('html');
      body.classList.remove('body-overflow')
  let content = document.querySelector('.contentainer-diploma');
  // 
  addClassElement(content, 'd-none');
}
const statusBtnDiploma = () => {
  // let btnDiploma = document.querySelector('.generate-diploma');  
  // // 
  // if(JSON.parse(localStorage?.getItem("Categoria")) != null){
  //   let dataUser = JSON.parse( localStorage?.getItem("dataUser") );
  //   let data = getDataCategorie(dataUser, dataUser.Categoria) 
  //   let info = [];
  //       data.map(ele => {
  //         if (ele.status === 1){
  //           info.push(ele); 
  //         }
  //       });
  //   if(info.length === 27){
  //     removeClass(btnDiploma, 'd-none');
  //   }else{
  //     addClassElement(btnDiploma, 'd-none')    
  //   }
  // }  
}
let diploma = getElement('btn-generate-diploma', '');
let = getElement('close-form', '');
// diploma.addEventListener("click", comprobationDiploma);
// closeDiploma.addEventListener("click", closeForm);
// 
const constraints = {
  video: { facingMode: 'user', width: 420, height: 340 },
  audio: false,
};
const getVideo = async () => {
    if (!tieneSoporteUserMedia()) {
        alert("Lo siento. Tu navegador no soporta esta característica");
        return;
    }
    try {
        const stream = await navigator.mediaDevices.getUserMedia(constraints);
        handleSucces(stream);
    } catch (error) {
        console.log(error);
    }
};
const handleSucces = (stream) => {
  video.srcObject = stream;
  video.play();
};
const showPicture = (picture ) => {
    addClassElement($overlay, 'd-none');
    actionFoto(1);
    $foto_tomada.dataset.foto = picture;
}
const cleanFoto = () => {
    actionFoto(2);    
    $foto_tomada.dataset.foto = '';
}
const actionFoto = (type) => {
    // 
    if(type === 1) {
      addClassElement($video, 'd-none')
      removeClass($canvas, 'd-none');
    }else{
      addClassElement($canvas, 'd-none')        
      removeClass($video, 'd-none')
    }    
} 
const validarCaracteresInput = (expresion, input, campo) => {
	if(expresion.test(input.value)){
    getElement(campo, '').classList.remove('input-value-incorrect');
    getElement(campo, '').classList.add('input-value-correct');
	} else {
    getElement(campo, '').classList.add('input-value-incorrect');
		getElement(campo, '').classList.remove('input-value-correct');
	}
}
const validarCaracteres = (e) =>{
	switch (e.target.name) {
		case 'NameUser':
			validarCaracteresInput(expresiones.Nombre, e.target, 'NameUser');			
			break;									
		case 'EmailUser':
			validarCaracteresInput(expresiones.Correo, e.target, 'EmailUser');			
			break;		
	}
}
const searchTabs = (e) => {
  let item =  e.target;
  let id_item =  item.dataset.tab;
  let categorie = item.dataset.categoria;
  let active_item = getQueryElement('#tab-'+id_item);
  let data =  getDataCategorie(categorie); 
  const contentBody = getQueryElement('body');
  const bgCalendar = getQueryElement('#bg_calendario');
  const colorTitle = getQueryElement('#content_title');
  const btReload = getAllElement('.btn-diploma');
  const contentItems = getQueryElement('.container-calendar .schedule-calendar');
        contentItems.innerHTML = '';
  // 
  localStorage.setItem("Categoria", JSON.stringify(categorie));   
  setItemsExercises(data, categorie);    
  removeAllClass($tabs, 'tab-active');
  addClassElement(active_item, 'tab-active');
  let classCalendar = {
                          '1' : 'calendar-basic',
                          '2' : 'calendar-intermediate',
                          '3' : 'calendar-hard',
                      }
  let backgroundCalendar = {
                          '1' : 'bg-calendar-principiante',
                          '2' : 'bg-calendar-intermedio',
                          '3' : 'bg-calendar-avanzado',
                      }
  let backgroundTitle = {
                          '1' : 'title-color-principiante',
                          '2' : 'title-color-intermedio',
                          '3' : 'title-color-avanzado',
                      }
  let btnReload = {
                          '1' : 'btn-reload-calendar-basic',
                          '2' : 'btn-reload-calendar-intermediate',
                          '3' : 'btn-reload-calendar-hard',
                      }
  contentBody.setAttribute('class', 'light-page')
  addClassElement(contentBody, classCalendar[categorie]);  
  //  
  bgCalendar.setAttribute('class', 'bg-wrap')
  addClassElement(bgCalendar, backgroundCalendar[categorie]);     
  // 
  colorTitle.setAttribute('class', 'content-title')
  addClassElement(colorTitle, backgroundTitle[categorie]);   
  // 
  addAllClass(btReload, 'd-none');
  let id_btn_reload = getQueryElement('#'+btnReload[categorie]);
  console.log(id_btn_reload);
  removeClass(id_btn_reload, 'd-none')
}
const comprobationCategorieClass = () => {
  const contentItems = document.querySelector('body');
  const bgCalendar = document.querySelector('#bg_calendario');
  const colorTitle = document.querySelector('#content_title');

  let categoria_activa = getQueryElement('.tab-active');  
  
  let categoria = ( JSON.parse(localStorage?.getItem("Categoria")) == null) 
                  ? categoria_activa.dataset.categoria : 
                   JSON.parse(localStorage?.getItem("Categoria"));
  let classCalendar = {
                          '1' : 'calendar-basic',
                          '2' : 'calendar-intermediate',
                          '3' : 'calendar-hard',
                      }
  let backgroundCalendar = {
                            '1' : 'bg-calendar-principiante',
                            '2' : 'bg-calendar-intermedio',
                            '3' : 'bg-calendar-avanzado',                      
                          }
  let backgroundTitle = {
                            '1' : 'title-color-principiante',
                            '2' : 'title-color-intermedio',
                            '3' : 'title-color-avanzado',                          
                        }
  let active_item = getQueryElement('.tab-'+categoria);
  removeAllClass($tabs, 'tab-active');
  addClassElement(active_item, 'tab-active');
  addClassElement(contentItems, classCalendar[categoria]);     
  // 
  bgCalendar.setAttribute('class', 'bg-wrap')    
  addClassElement(bgCalendar, backgroundCalendar[categoria]);     
  // 
  colorTitle.setAttribute('class', 'content-title')
  addClassElement(colorTitle, backgroundTitle[categoria]);   
}
const reloadCalendar = async(e) => {
  let categorie = e.target.dataset.categoria; 
  const ejercicios = await completeDataStorage(parseInt(categorie));
  
  switch (categorie) {
    case '1':
      localStorage.setItem("_1", JSON.stringify(ejercicios));
      break;
    case '2':
      localStorage.setItem("_2", JSON.stringify(ejercicios));
      break;
    case '3':
      localStorage.setItem("_3", JSON.stringify(ejercicios));
      break;    
  }  
  setItemsExercises(ejercicios, categorie); 
  $([document.documentElement, document.body]).animate({
      scrollTop: $("#desc-textbox-img").offset().top - 69
  }, 500);
}
$boton.addEventListener("click", function() {
  //Pausar reproducción
  $video.pause();
  //Obtener contexto del canvas y dibujar sobre él
  let contexto = $canvas.getContext("2d");
  $canvas.width = $video.videoWidth;
  $canvas.height = $video.videoHeight;
  contexto.drawImage($video, 0, 0, $canvas.width, $canvas.height);
  // 
  let foto = $canvas.toDataURL(); //Esta es la foto, en base 64
  showPicture(foto)
  $boton.disabled = true;
  $boton_clean.disabled = false;
  // let enlace = document.createElement('a'); // Crear un <a>
  // enlace.download = "foto_parzibyte.me.png";
  // enlace.href = foto;
  // enlace.click();
  //Reanudar reproducción
  // $video.play();
});
$boton_clean.addEventListener("click", function() {
  let contexto = $canvas.getContext("2d");
  $canvas.width = $video.videoWidth;
  $canvas.height = $video.videoHeight;                    
  contexto.clearRect(0, 0, $canvas.width, $canvas.height);
  // 
  cleanFoto();          
  removeClass($overlay, 'd-none');
  $boton.disabled = false;
  $boton_clean.disabled = true;
  // 
  $video.play();
});
$input.forEach((input) =>{
  input.addEventListener('keyup', validarCaracteres);
});   
$form.addEventListener('submit', (e) => {
  e.preventDefault();
  let nombre = e.srcElement[2].value;
  let correo = e.srcElement[3].value;
  let foto = $foto_tomada.dataset.foto;
  // 
  downloadDiploma(nombre, correo, foto);
});
$tabs.forEach((tabs) =>{
  tabs.addEventListener('click', searchTabs);
});  
$btn_reload.forEach((btn) =>{
  btn.addEventListener('click', reloadCalendar);
});  
function downloadDiploma(name, mail, picture) {
  let ContainerDiploma =  document.querySelector('.container-diploma');
  let diploma =  document.querySelector('.container-diploma .diploma');
  let foto =  document.querySelector('.container-diploma .diploma .info-diploma .foto');
  let nombre =  document.querySelector('.container-diploma .diploma .info-diploma .datos h2');
  let correo =  document.querySelector('.container-diploma .diploma .info-diploma .datos h3');
      foto.style = `background-image: url('${picture}')`;
      nombre.innerHTML = `<strong>Nombre: <strong> ${name}`;
      correo.innerHTML = `<strong>Correo: <strong> ${mail}`;
      html2canvas(diploma).then(canvas => {
        var a = document.createElement('a');
        a.href = canvas.toDataURL("image/jpeg").replace("image/jpeg", "image/octet-stream");
        a.download = 'somefilename.jpg';
        a.click();
      });
}
setTimeout(function(){
  $('.preloader').fadeOut(1000);
}, 1500);
document.addEventListener("DOMContentLoaded", function(event) {        
  readLocalStorage();
  comprobationCategorieClass();
  alertDisclaimer();
  // statusBtnDiploma();
  // comprobationDiploma()
});
